function [G1,G2,G3] = EstGradient(X,h,D,smooth)


  
sz = size(X);

for d = 1:length(D)
  if nargin > 3
    S = MakeSmooth(X,smooth,D(d),ndims(X));
  else
    S = X;
  end
  if (sz(2) == 1) & (D(d)==1)
    K = h(d);
    K = sum(K{:},2);
  else
    K = h(d);
    K = K{:};
  end
  
  eval(strcat('G',num2str(d),' = convn(S,K,''same'');'));
end


function S = MakeSmooth(X,smooth,d,n)
S = X;
for g = 1:n
  k = smooth(g);
  if (g ~= d) & (length(k{:})>1)
    S = convn(S,k{:},'same');
  end
end  
