function  [motionvector,lowresdist,V]=progmotionestimation(a,res,handdistribtext)
%written by Sina farsiu Nov2nd 2003
global V
clear V;
handles.distribtext=handdistribtext;
z=size(a);

atemp=zeros(z(1),z(2),2);%a temporal place of keeping the reference frame and the other frame
%Dirk Robinson Method

meth.grad =  'gradd';
meth.W = 1;
meth.smooth = 1;
meth.reg = 2.2204e-016;
meth.name = 'gTrEst2';
 
hm = waitbar(0,'Please wait for motion estimation');
for i=1:z(3)-1
    atemp(:,:,1)=a(:,:,i);%reference frame  
    atemp(:,:,2)=a(:,:,i+1);
    V(:,i) = PyrRegister2(atemp,meth,3,2);
    waitbar(i/(z(3)-1))
end
close(hm)
V(2,:)=-V(2,:);
fol=zeros(2,z(3)-1);
    for i=2:z(3)
        fol(:,i)=fol(:,i-1)+V(:,i-1);%although the motion is estimated from each two consequtive frames the program needs 
        %to know the motion from the first frame to each other frame 
    end
 V=fol(:,2:z(3));

[motionvector lowresdist ]=distriblow2(V,res,z,handles.distribtext);